<?php
/**
 * Prime SEO Agency Theme Customizer.
 *
 * @link https://developer.wordpress.org/themes/basics/theme-functions/
 *
 * @package prime_seo_agency
 */

if( ! function_exists( 'prime_seo_agency_customize_register' ) ):  
/**
 * Add postMessage support for site title and description for the Theme Customizer.F
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function prime_seo_agency_customize_register( $wp_customize ) {
    require get_parent_theme_file_path('/inc/controls/changeable-icon.php');

    require get_parent_theme_file_path('/inc/controls/sortable-control.php');
    
    //Register the sortable control type.
    $wp_customize->register_control_type( 'Prime_Seo_Agency_Control_Sortable' ); 
    
    if ( version_compare( get_bloginfo('version'),'4.9', '>=') ) {
        $wp_customize->get_section( 'static_front_page' )->title = __( 'Static Front Page', 'prime-seo-agency' );
    }
	
    /* Option list of all post */	
    $prime_seo_agency_options_posts = array();
    $prime_seo_agency_options_posts_obj = get_posts('posts_per_page=-1');
    $prime_seo_agency_options_posts[''] = esc_html__( 'Choose Post', 'prime-seo-agency' );
    foreach ( $prime_seo_agency_options_posts_obj as $prime_seo_agency_posts ) {
    	$prime_seo_agency_options_posts[$prime_seo_agency_posts->ID] = $prime_seo_agency_posts->post_title;
    }
    
    /* Option list of all categories */
    $prime_seo_agency_args = array(
	   'type'                     => 'post',
	   'orderby'                  => 'name',
	   'order'                    => 'ASC',
	   'hide_empty'               => 1,
	   'hierarchical'             => 1,
	   'taxonomy'                 => 'category'
    ); 
    $prime_seo_agency_option_categories = array();
    $prime_seo_agency_category_lists = get_categories( $prime_seo_agency_args );
    $prime_seo_agency_option_categories[''] = esc_html__( 'Choose Category', 'prime-seo-agency' );
    foreach( $prime_seo_agency_category_lists as $prime_seo_agency_category ){
        $prime_seo_agency_option_categories[$prime_seo_agency_category->term_id] = $prime_seo_agency_category->name;
    }
    
    /** Default Settings */    
    $wp_customize->add_panel( 
        'wp_default_panel',
         array(
            'priority' => 10,
            'capability' => 'edit_theme_options',
            'theme_supports' => '',
            'title' => esc_html__( 'Default Settings', 'prime-seo-agency' ),
            'description' => esc_html__( 'Default section provided by wordpress customizer.', 'prime-seo-agency' ),
        ) 
    );
    
    $wp_customize->get_section( 'title_tagline' )->panel                  = 'wp_default_panel';
    $wp_customize->get_section( 'colors' )->panel                         = 'wp_default_panel';
    $wp_customize->get_section( 'header_image' )->panel                   = 'wp_default_panel';
    $wp_customize->get_section( 'background_image' )->panel               = 'wp_default_panel';
    $wp_customize->get_section( 'static_front_page' )->panel              = 'wp_default_panel';
    
    $wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';
    
    /** Default Settings Ends */
    
    /** Site Title control */
    $wp_customize->add_setting( 
        'header_site_title', 
        array(
            'default'           => false,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_site_title',
        array(
            'label'       => __( 'Show / Hide Site Title', 'prime-seo-agency' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    /** Tagline control */
    $wp_customize->add_setting( 
        'header_tagline', 
        array(
            'default'           => false,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'header_tagline',
        array(
            'label'       => __( 'Show / Hide Tagline', 'prime-seo-agency' ),
            'section'     => 'title_tagline',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('logo_width', array(
        'sanitize_callback' => 'absint', 
    ));

    // Add a control for logo width
    $wp_customize->add_control('logo_width', array(
        'label' => __('Logo Width', 'prime-seo-agency'),
        'section' => 'title_tagline',
        'type' => 'number',
        'input_attrs' => array(
            'min' => '50', 
            'max' => '500', 
            'step' => '5', 
    ),
        'default' => '100', 
    ));

    $wp_customize->add_setting( 'prime_seo_agency_site_title_size', array(
        'default'           => 30, // Default font size in pixels
        'sanitize_callback' => 'absint', // Sanitize the input as a positive integer
    ) );

    // Add control for site title size
    $wp_customize->add_control( 'prime_seo_agency_site_title_size', array(
        'type'        => 'number',
        'section'     => 'title_tagline', // You can change this section to your preferred section
        'label'       => __( 'Site Title Font Size (px)', 'prime-seo-agency' ),
        'input_attrs' => array(
            'min'  => 10,
            'max'  => 100,
            'step' => 1,
        ),
    ) );

    //Global Color
    $wp_customize->add_section(
        'prime_seo_agency_global_color',
        array(
            'title' => esc_html__( 'Global Color Settings', 'prime-seo-agency' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'prime_seo_agency_general_settings',
        )
    );

    $wp_customize->add_setting('prime_seo_agency_primary_color', array(
        'default'           => '#3aafa9',
        'sanitize_callback' => 'sanitize_hex_color',
    ));
    $wp_customize->add_control(new WP_Customize_Color_Control($wp_customize, 'prime_seo_agency_primary_color', array(
        'label'    => __('Theme Primary Color', 'prime-seo-agency'),
        'section'  => 'prime_seo_agency_global_color',
        'settings' => 'prime_seo_agency_primary_color',
    )));    

    /** Post & Pages Settings */
    $wp_customize->add_panel( 
        'prime_seo_agency_post_settings',
         array(
            'priority' => 40,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Post & Pages Settings', 'prime-seo-agency' ),
            'description' => esc_html__( 'Customize Post & Pages Settings', 'prime-seo-agency' ),
        ) 
    );

        /** Post Layouts */
    
    $wp_customize->add_section(
        'prime_seo_agency_post_layout_section',
        array(
            'title' => esc_html__( 'Post Layout Settings', 'prime-seo-agency' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'prime_seo_agency_post_settings',
        )
    );

    $wp_customize->add_setting('prime_seo_agency_post_layout_setting', array(
        'default'           => 'right-sidebar',
        'sanitize_callback' => 'prime_seo_agency_sanitize_post_layout',
    ));

    $wp_customize->add_control('prime_seo_agency_post_layout_setting', array(
        'label'    => __('Post Column Settings', 'prime-seo-agency'),
        'section'  => 'prime_seo_agency_post_layout_section',
        'settings' => 'prime_seo_agency_post_layout_setting',
        'type'     => 'select',
        'choices'  => array(        
            'right-sidebar'   => __('Right Sidebar', 'prime-seo-agency'),
            'left-sidebar'   => __('Left Sidebar', 'prime-seo-agency'),
            'one-column'   => __('One Column', 'prime-seo-agency'),
            'three-column'   => __('Three Columns', 'prime-seo-agency'),
            'four-column'   => __('Four Columns', 'prime-seo-agency'),
            'grid-layout'   => __('Grid Layout', 'prime-seo-agency')
        ),
    ));


    $wp_customize->add_setting('prime_seo_agency_archive_pagination_alignment',array(
        'default' => 'left-align',
        'sanitize_callback' => 'prime_seo_agency_sanitize_pagination_alignment'
    ));
    $wp_customize->add_control('prime_seo_agency_archive_pagination_alignment',array(
        'type' => 'select',
        'label' => __('Pagination Alignment','prime-seo-agency'),
        'section' => 'prime_seo_agency_post_layout_section',
        'choices' => array(
            'right-align' => __('Right Alignment','prime-seo-agency'),
            'center-align' => __('Center Alignment','prime-seo-agency'),
            'left-align' => __('Left Alignment','prime-seo-agency'),
        ),
    ) );

     /** Post Layouts Ends */
     
    /** Post Settings */
    $wp_customize->add_section(
        'prime_seo_agency_post_settings',
        array(
            'title' => esc_html__( 'Post Settings', 'prime-seo-agency' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'prime_seo_agency_post_settings',
        )
    );

    /** Post Heading control */
    $wp_customize->add_setting( 
        'prime_seo_agency_post_heading_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_post_heading_setting',
        array(
            'label'       => __( 'Show / Hide Post Heading', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Meta control */
    $wp_customize->add_setting( 
        'prime_seo_agency_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Post Meta', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Image control */
    $wp_customize->add_setting( 
        'prime_seo_agency_post_image_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_post_image_setting',
        array(
            'label'       => __( 'Show / Hide Post Image', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Post Content control */
    $wp_customize->add_setting( 
        'prime_seo_agency_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Post Content', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_post_settings',
            'type'        => 'checkbox',
        )
    );
    /** Post ReadMore control */
     $wp_customize->add_setting( 'prime_seo_agency_read_more_setting', array(
        'default'           => true,
        'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
    ) );

    $wp_customize->add_control( 'prime_seo_agency_read_more_setting', array(
        'type'        => 'checkbox',
        'section'     => 'prime_seo_agency_post_settings', 
        'label'       => __( 'Display Read More Button', 'prime-seo-agency' ),
    ) );

    $wp_customize->add_setting('prime_seo_agency_single_post_align',array(
        'default' => 'left-align',
        'sanitize_callback' => 'prime_seo_agency_sanitize_post_content_align'
    ));
    $wp_customize->add_control('prime_seo_agency_single_post_align',array(
        'type' => 'select',
        'label' => __('Post Content Alignment','prime-seo-agency'),
        'section' => 'prime_seo_agency_post_settings',
        'choices' => array(
            'left-align' => __('Left Alignment','prime-seo-agency'),
            'right-align' => __('Right Alignment','prime-seo-agency'),
            'center-align' => __('Center Alignment','prime-seo-agency'),
        ),
    ) );

    $wp_customize->add_setting('prime_seo_agency_blog_meta_order', array(
        'default' => array('heading', 'author', 'featured-image', 'content','button'),
        'sanitize_callback' => 'prime_seo_agency_sanitize_sortable',
    ));
    $wp_customize->add_control(new Prime_Seo_Agency_Control_Sortable($wp_customize, 'prime_seo_agency_blog_meta_order', array(
        'label' => esc_html__('Post Meta Ordering', 'prime-seo-agency'),
        'description' => __('Drag & drop post items to rearrange the ordering ( this control will not function by post format )', 'prime-seo-agency') ,
        'section' => 'prime_seo_agency_post_settings',
        'choices' => array(
            'heading' => __('heading', 'prime-seo-agency') ,
            'author' => __('author', 'prime-seo-agency') ,
            'featured-image' => __('featured-image', 'prime-seo-agency') ,
            'content' => __('content', 'prime-seo-agency') ,
            'button' => __('button', 'prime-seo-agency') ,
        ) ,
    )));


    /** Post Settings Ends */

     /** Single Post Settings */
    $wp_customize->add_section(
        'prime_seo_agency_single_post_settings',
        array(
            'title' => esc_html__( 'Single Post Settings', 'prime-seo-agency' ),
            'priority' => 20,
            'capability' => 'edit_theme_options',
            'panel' => 'prime_seo_agency_post_settings',
        )
    );

    /** Single Post Meta control */
    $wp_customize->add_setting( 
        'prime_seo_agency_single_post_meta_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_single_post_meta_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Meta', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Content control */
    $wp_customize->add_setting( 
        'prime_seo_agency_single_post_content_setting', 
        array(
            'default'           => true,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_single_post_content_setting',
        array(
            'label'       => __( 'Show / Hide Single Post Content', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_single_post_settings',
            'type'        => 'checkbox',
        )
    );

    /** Single Post Settings Ends */

    // Typography Settings Section
    $wp_customize->add_section('prime_seo_agency_typography_settings', array(
        'title'      => esc_html__('Typography Settings', 'prime-seo-agency'),
        'priority'   => 30,
        'capability' => 'edit_theme_options',
        'panel' => 'prime_seo_agency_general_settings',
    ));

    // Array of fonts to choose from
    $font_choices = array(
        ''               => __('Select', 'prime-seo-agency'),
        'Arial'          => 'Arial, sans-serif',
        'Verdana'        => 'Verdana, sans-serif',
        'Helvetica'      => 'Helvetica, sans-serif',
        'Times New Roman'=> '"Times New Roman", serif',
        'Georgia'        => 'Georgia, serif',
        'Courier New'    => '"Courier New", monospace',
        'Trebuchet MS'   => '"Trebuchet MS", sans-serif',
        'Tahoma'         => 'Tahoma, sans-serif',
        'Palatino'       => '"Palatino Linotype", serif',
        'Garamond'       => 'Garamond, serif',
        'Impact'         => 'Impact, sans-serif',
        'Comic Sans MS'  => '"Comic Sans MS", cursive, sans-serif',
        'Lucida Sans'    => '"Lucida Sans Unicode", sans-serif',
        'Arial Black'    => '"Arial Black", sans-serif',
        'Gill Sans'      => '"Gill Sans", sans-serif',
        'Segoe UI'       => '"Segoe UI", sans-serif',
        'Open Sans'      => '"Open Sans", sans-serif',
        'Roboto'         => 'Roboto, sans-serif',
        'Lato'           => 'Lato, sans-serif',
        'Montserrat'     => 'Montserrat, sans-serif',
        'Libre Baskerville' => 'Libre Baskerville',
    );

    // Heading Font Setting
    $wp_customize->add_setting('prime_seo_agency_heading_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'prime_seo_agency_sanitize_choicess',
    ));
    $wp_customize->add_control('prime_seo_agency_heading_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Heading', 'prime-seo-agency'),
        'section' => 'prime_seo_agency_typography_settings',
    ));

    // Body Font Setting
    $wp_customize->add_setting('prime_seo_agency_body_font_family', array(
        'default'           => '',
        'sanitize_callback' => 'prime_seo_agency_sanitize_choicess',
    ));
    $wp_customize->add_control('prime_seo_agency_body_font_family', array(
        'type'    => 'select',
        'choices' => $font_choices,
        'label'   => __('Select Font for Body', 'prime-seo-agency'),
        'section' => 'prime_seo_agency_typography_settings',
    ));

    /** Typography Settings Section End */

    /** General Settings */
    $wp_customize->add_panel( 
        'prime_seo_agency_general_settings',
         array(
            'priority' => 40,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'General Settings', 'prime-seo-agency' ),
            'description' => esc_html__( 'Customize General Settings', 'prime-seo-agency' ),
        ) 
    );

    /** General Settings */
    $wp_customize->add_section(
        'prime_seo_agency_general_settings',
        array(
            'title' => esc_html__( 'Loader Settings', 'prime-seo-agency' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'prime_seo_agency_general_settings',
        )
    );

    /** Preloader control */
    $wp_customize->add_setting( 
        'prime_seo_agency_header_preloader', 
        array(
            'default' => false,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_header_preloader',
        array(
            'label'       => __( 'Show Preloader', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_general_settings',
            'type'        => 'checkbox',
        )
    );

    $wp_customize->add_setting('prime_seo_agency_loader_layout_setting', array(
        'default' => 'load',
        'sanitize_callback' => 'sanitize_text_field',
    ));

    // Add control for loader layout
    $wp_customize->add_control('prime_seo_agency_loader_layout_control', array(
        'label' => __('Preloader Layout', 'prime-seo-agency'),
        'section' => 'prime_seo_agency_general_settings',
        'settings' => 'prime_seo_agency_loader_layout_setting',
        'type' => 'select',
        'choices' => array(
            'load' => __('Preloader 1', 'prime-seo-agency'),
            'load-one' => __('Preloader 2', 'prime-seo-agency'),
            'ctn-preloader' => __('Preloader 3', 'prime-seo-agency'),
        ),
    ));

    $wp_customize->add_setting('prime_seo_agency_theme_width',array(
        'default' => 'full-width',
        'sanitize_callback' => 'prime_seo_agency_sanitize_theme_width'
    ));
    $wp_customize->add_control('prime_seo_agency_theme_width',array(
        'type' => 'select',
        'label' => __('Theme Width Option','prime-seo-agency'),
        'section' => 'prime_seo_agency_general_settings',
        'choices' => array(
            'full-width' => __('Fullwidth','prime-seo-agency'),
            'container' => __('Container','prime-seo-agency'),
            'container-fluid' => __('Container Fluid','prime-seo-agency'),
        ),
    ) );

    /** Header Section Settings */
    $wp_customize->add_section(
        'prime_seo_agency_header_section_settings',
        array(
            'title' => esc_html__( 'Header Section Settings', 'prime-seo-agency' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'prime_seo_agency_home_page_settings',
        )
    );

    /** Header Section control */
    $wp_customize->add_setting( 
        'prime_seo_agency_header_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_header_setting',
        array(
            'label'       => __( 'Show Header', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_header_section_settings',
            'type'        => 'checkbox',
        )
    );

     /** Email */
    $wp_customize->add_setting(
        'prime_seo_agency_header_email',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'prime_seo_agency_header_email',
        array(
            'label' => esc_html__( 'Add Email', 'prime-seo-agency' ),
            'section' => 'prime_seo_agency_header_section_settings',
            'type' => 'text',
        )
    );

    $wp_customize->add_setting('prime_seo_agency_mail_icon',array(
        'default'   => 'fas fa-envelope',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Prime_SEO_Agency_Changeable_Icon(
        $wp_customize,'prime_seo_agency_mail_icon',array(
        'label' => __('Mail Icon','prime-seo-agency'),
        'transport' => 'refresh',
        'section'   => 'prime_seo_agency_header_section_settings',
        'type'      => 'icon'
    )));

    /** Phone */
    $wp_customize->add_setting(
        'prime_seo_agency_header_phone',
        array( 
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'prime_seo_agency_header_phone',
        array(
            'label' => esc_html__( 'Add Phone', 'prime-seo-agency' ),
            'section' => 'prime_seo_agency_header_section_settings',
            'type' => 'text',
        )
    );
    $wp_customize->add_setting('prime_seo_agency_phone_icon',array(
        'default'   => 'fas fa-phone-volume',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Prime_SEO_Agency_Changeable_Icon(
        $wp_customize,'prime_seo_agency_phone_icon',array(
        'label' => __('Phone Icon','prime-seo-agency'),
        'transport' => 'refresh',
        'section'   => 'prime_seo_agency_header_section_settings',
        'type'      => 'icon'
    )));

    $wp_customize->add_setting( 
        'prime_seo_agency_show_hide_search', 
        array(
            'default' => false ,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_show_hide_search',
        array(
            'label'       => __( 'Show Search Icon', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_header_section_settings',
            'type'        => 'checkbox',
        )
    );
    $wp_customize->add_setting('prime_seo_agency_search_icon',array(
        'default'   => 'fas fa-search',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Prime_SEO_Agency_Changeable_Icon(
        $wp_customize,'prime_seo_agency_search_icon',array(
        'label' => __('Search Icon','prime-seo-agency'),
        'transport' => 'refresh',
        'section'   => 'prime_seo_agency_header_section_settings',
        'type'      => 'icon'
    )));

    /** Sticky Header control */
    $wp_customize->add_setting( 
        'prime_seo_agency_sticky_header', 
        array(
            'default' => false,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_sticky_header',
        array(
            'label'       => __( 'Show Sticky Header', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_header_section_settings',
            'type'        => 'checkbox',
        )
    );

    // Add Setting for Menu Font Weight
    $wp_customize->add_setting( 'menu_font_weight', array(
        'default'           => '600',
        'sanitize_callback' => 'prime_seo_agency_sanitize_font_weight',
    ) );

    // Add Control for Menu Font Weight
    $wp_customize->add_control( 'menu_font_weight', array(
        'label'    => __( 'Menu Font Weight', 'prime-seo-agency' ),
        'section'  => 'prime_seo_agency_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            '100' => __( '100 - Thin', 'prime-seo-agency' ),
            '200' => __( '200 - Extra Light', 'prime-seo-agency' ),
            '300' => __( '300 - Light', 'prime-seo-agency' ),
            '400' => __( '400 - Normal', 'prime-seo-agency' ),
            '500' => __( '500 - Medium', 'prime-seo-agency' ),
            '600' => __( '600 - Semi Bold', 'prime-seo-agency' ),
            '700' => __( '700 - Bold', 'prime-seo-agency' ),
            '800' => __( '800 - Extra Bold', 'prime-seo-agency' ),
            '900' => __( '900 - Black', 'prime-seo-agency' ),
        ),
    ) );

    // Add Setting for Menu Text Transform
    $wp_customize->add_setting( 'menu_text_transform', array(
        'default'           => 'capitalize',
        'sanitize_callback' => 'prime_seo_agency_sanitize_text_transform',
    ) );

    // Add Control for Menu Text Transform
    $wp_customize->add_control( 'menu_text_transform', array(
        'label'    => __( 'Menu Text Transform', 'prime-seo-agency' ),
        'section'  => 'prime_seo_agency_header_section_settings',
        'type'     => 'select',
        'choices'  => array(
            'none'       => __( 'None', 'prime-seo-agency' ),
            'capitalize' => __( 'Capitalize', 'prime-seo-agency' ),
            'uppercase'  => __( 'Uppercase', 'prime-seo-agency' ),
            'lowercase'  => __( 'Lowercase', 'prime-seo-agency' ),
        ),
    ) );

    // Menu Hover Style	
    $wp_customize->add_setting('prime_seo_agency_menus_style',array(
        'default' => '',
        'sanitize_callback' => 'prime_seo_agency_sanitize_choices'
	));
	$wp_customize->add_control('prime_seo_agency_menus_style',array(
        'type' => 'select',
		'label' => __('Menu Hover Style','prime-seo-agency'),
		'section' => 'prime_seo_agency_header_section_settings',
		'choices' => array(
         'None' => __('None','prime-seo-agency'),
         'Zoom In' => __('Zoom In','prime-seo-agency'),
      ),
	));

    /** Header Section Settings End */

    /** Socail Section Settings */
    $wp_customize->add_section(
        'prime_seo_agency_social_section_settings',
        array(
            'title' => esc_html__( 'Social Media Section Settings', 'prime-seo-agency' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'prime_seo_agency_home_page_settings',
        )
    );

    /** Socail Section control */
    $wp_customize->add_setting( 
        'prime_seo_agency_social_icon_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_social_icon_setting',
        array(
            'label'       => __( 'Show Social Icon', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_social_section_settings',
            'type'        => 'checkbox',
        )
    );

    /**  Social Link 1 */
    $wp_customize->add_setting(
        'prime_seo_agency_social_link_1',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'prime_seo_agency_social_link_1',
        array(
            'label' => esc_html__( 'Add Facebook Link', 'prime-seo-agency' ),
            'section' => 'prime_seo_agency_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 2 */
    $wp_customize->add_setting(
        'prime_seo_agency_social_link_2',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'prime_seo_agency_social_link_2',
        array(
            'label' => esc_html__( 'Add Twitter Link', 'prime-seo-agency' ),
            'section' => 'prime_seo_agency_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 3 */
    $wp_customize->add_setting(
        'prime_seo_agency_social_link_3',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'prime_seo_agency_social_link_3',
        array(
            'label' => esc_html__( 'Add Instagram Link', 'prime-seo-agency' ),
            'section' => 'prime_seo_agency_social_section_settings',
            'type' => 'url',
        )
    );

    /**  Social Link 4 */
    $wp_customize->add_setting(
        'prime_seo_agency_social_link_4',
        array( 
            'default' => '',
            'sanitize_callback' => 'esc_url_raw',
            'transport'         => 'refresh'
        )
    );
    
    $wp_customize->add_control(
        'prime_seo_agency_social_link_4',
        array(
            'label' => esc_html__( 'Add Pintrest Link', 'prime-seo-agency' ),
            'section' => 'prime_seo_agency_social_section_settings',
            'type' => 'url',
        )
    );

    /** Socail Section Settings End */

    /** Home Page Settings */
    $wp_customize->add_panel( 
        'prime_seo_agency_home_page_settings',
         array(
            'priority' => 9,
            'capability' => 'edit_theme_options',
            'title' => esc_html__( 'Home Page Settings', 'prime-seo-agency' ),
            'description' => esc_html__( 'Customize Home Page Settings', 'prime-seo-agency' ),
        ) 
    );

    /** Slider Section Settings */
    $wp_customize->add_section(
        'prime_seo_agency_slider_section_settings',
        array(
            'title' => esc_html__( 'Slider Section Settings', 'prime-seo-agency' ),
            'priority' => 30,
            'capability' => 'edit_theme_options',
            'panel' => 'prime_seo_agency_home_page_settings',
        )
    );

    /** Slider Section control */
    $wp_customize->add_setting( 
        'prime_seo_agency_slider_setting', 
        array(
            'default' => false,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_slider_setting',
        array(
            'label'       => __( 'Show Slider', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_slider_section_settings',
            'type'        => 'checkbox',
        )
    );
    
    $categories = get_categories();
        $cat_posts = array();
            $i = 0;
            $cat_posts[]='Select';
        foreach($categories as $category){
            if($i==0){
            $default = $category->slug;
            $i++;
        }
        $cat_posts[$category->slug] = $category->name;
    }

    $wp_customize->add_setting(
        'prime_seo_agency_blog_slide_category',
        array(
            'default'   => 'select',
            'sanitize_callback' => 'prime_seo_agency_sanitize_choices',
        )
    );
    $wp_customize->add_control(
        'prime_seo_agency_blog_slide_category',
        array(
            'type'    => 'select',
            'choices' => $cat_posts,
            'label' => __('Select Category to display Latest Post','prime-seo-agency'),
            'section' => 'prime_seo_agency_slider_section_settings',
        )
    );

    // Section Text
    $wp_customize->add_setting('prime_seo_agency_slider_second_button_url', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('prime_seo_agency_slider_second_button_url', 
        array(
        'label'       => __('Slider Second Button URL', 'prime-seo-agency'),
        'section'     => 'prime_seo_agency_slider_section_settings',   
        'settings'    => 'prime_seo_agency_slider_second_button_url',
        'type'        => 'url'
        )
    );

    /** About Section Settings */
    
    $wp_customize->add_section( 'prime_seo_agency_section_featured_about',
        array(
        'title'      => __( 'About Us Section', 'prime-seo-agency' ),
        'priority'   => 110,
        'capability' => 'edit_theme_options',
        'panel' => 'prime_seo_agency_home_page_settings',
        )
    );

    /** About Section control */
    $wp_customize->add_setting( 
        'prime_seo_agency_about_setting', 
        array(
            'default'           => false,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_about_setting',
        array(
            'label'       => __( 'Show / Hide About', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_section_featured_about',
            'type'        => 'checkbox',
        )
    );

    // Section Title
    $wp_customize->add_setting('prime_seo_agency_featured_mission_section_title', 
        array(
        'default'           => '',
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',    
        'sanitize_callback' => 'sanitize_text_field'
        )
    );

    $wp_customize->add_control('prime_seo_agency_featured_mission_section_title', 
        array(
        'label'       => __('Section Title', 'prime-seo-agency'),
        'section'     => 'prime_seo_agency_section_featured_about',   
        'settings'    => 'prime_seo_agency_featured_mission_section_title',
        'type'        => 'text'
        )
    );

    // Post
    $wp_customize->add_setting('prime_seo_agency_featured_mission_post_', 
        array(
        'type'              => 'theme_mod',
        'capability'        => 'edit_theme_options',
        'sanitize_callback' => 'prime_seo_agency_dropdown_pages'
        )
    );

    $wp_customize->add_control('prime_seo_agency_featured_mission_post_', 
        array(
        'label'       => __('Pages Dropdown', 'prime-seo-agency'),
        'section'     => 'prime_seo_agency_section_featured_about',   
        'settings'    => 'prime_seo_agency_featured_mission_post_',
        'type'        => 'dropdown-pages',
        )
    );
    


    
    /** Home Page Settings Ends */
    
    /** Footer Section */
    $wp_customize->add_section(
        'prime_seo_agency_footer_section',
        array(
            'title' => __( 'Footer Settings', 'prime-seo-agency' ),
            'priority' => 70,
            'panel' => 'prime_seo_agency_home_page_settings',
        )
    );

    /** Footer Widget Columns */
    $wp_customize->add_setting('prime_seo_agency_footer_widget_areas', array(
        'default'           => 4,
        'sanitize_callback' => 'prime_seo_agency_sanitize_choices',
    ));

    $wp_customize->add_control('prime_seo_agency_footer_widget_areas', array(
        'label'    => __('Footer Widget Columns', 'prime-seo-agency'),
        'section'  => 'prime_seo_agency_footer_section',
        'settings' => 'prime_seo_agency_footer_widget_areas',
        'type'     => 'select',
        'choices'  => array(
		   '1'     => __('One', 'prime-seo-agency'),
		   '2'     => __('Two', 'prime-seo-agency'),
		   '3'     => __('Three', 'prime-seo-agency'),
		   '4'     => __('Four', 'prime-seo-agency')
        ),
    ));

    /** Footer Copyright control */
    $wp_customize->add_setting( 
        'prime_seo_agency_footer_setting', 
        array(
            'default' => true,
            'sanitize_callback' => 'prime_seo_agency_sanitize_checkbox',
        ) 
    );

    $wp_customize->add_control(
        'prime_seo_agency_footer_setting',
        array(
            'label'       => __( 'Show Footer Copyright', 'prime-seo-agency' ),
            'section'     => 'prime_seo_agency_footer_section',
            'type'        => 'checkbox',
        )
    );
    
    /** Copyright Text */
    $wp_customize->add_setting(
        'prime_seo_agency_footer_copyright_text',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_text_field',
        )
    );
    
    $wp_customize->add_control(
        'prime_seo_agency_footer_copyright_text',
        array(
            'label' => __( 'Copyright Info', 'prime-seo-agency' ),
            'section' => 'prime_seo_agency_footer_section',
            'type' => 'text',
        )
    );  
$wp_customize->add_setting('footer_background_image',
        array(
        'default' => '',
        'capability' => 'edit_theme_options',
        'sanitize_callback' => 'absint',
        )
    );


    $wp_customize->add_control(
         new WP_Customize_Cropped_Image_Control($wp_customize, 'footer_background_image',
            array(
                'label' => esc_html__('Footer Background Image', 'prime-seo-agency'),
                /* translators: 1: image width in pixels, 2: image height in pixels */
                'description' => sprintf(esc_html__('Recommended Size %1$s px X %2$s px', 'prime-seo-agency'), 1024, 800),
                'section' => 'prime_seo_agency_footer_section',
                'width' => 1024,
                'height' => 800,
                'flex_width' => true,
                'flex_height' => true,
            )
        )
    );

    /** Footer Background Image Attachment */
    $wp_customize->add_setting('prime_seo_agency_background_attachment', array(
        'default'           => 'scroll',
        'sanitize_callback' => 'prime_seo_agency_sanitize_choices',
    ));

    $wp_customize->add_control('prime_seo_agency_background_attachment', array(
        'label'    => __('Footer Background Attachment', 'prime-seo-agency'),
        'section'  => 'prime_seo_agency_footer_section',
        'settings' => 'prime_seo_agency_background_attachment',
        'type'     => 'select',
        'choices'  => array(
            'fixed' => __('fixed','prime-seo-agency'),
            'scroll' => __('scroll','prime-seo-agency'),
        ),
    ));

    /* Footer Background Color*/
    $wp_customize->add_setting(
        'footer_background_color',
        array(
            'default' => '',
            'sanitize_callback' => 'sanitize_hex_color',
        )
    );
    $wp_customize->add_control(
        new WP_Customize_Color_Control(
            $wp_customize,
            'footer_background_color',
            array(
                'label' => __('Footer Widget Area Background Color', 'prime-seo-agency'),
                'section' => 'prime_seo_agency_footer_section',
                'type' => 'color',
            )
        )
    );

     $wp_customize->add_setting('prime_seo_agency_scroll_icon',array(
        'default'   => 'fas fa-arrow-up',
        'sanitize_callback' => 'sanitize_text_field'
    ));
    $wp_customize->add_control(new Prime_SEO_Agency_Changeable_Icon(
        $wp_customize,'prime_seo_agency_scroll_icon',array(
        'label' => __('Scroll Top Icon','prime-seo-agency'),
        'transport' => 'refresh',
        'section'   => 'prime_seo_agency_footer_section',
        'type'      => 'icon'
    )));

        $wp_customize->add_setting('prime_seo_agency_scroll_top_alignment',array(
        'default' => 'right-align',
        'sanitize_callback' => 'prime_seo_agency_sanitize_scroll_top_alignment'
    ));
    $wp_customize->add_control('prime_seo_agency_scroll_top_alignment',array(
        'type' => 'select',
        'label' => __('Scroll Top Alignment','prime-seo-agency'),
        'section' => 'prime_seo_agency_footer_section',
        'choices' => array(
            'right-align' => __('Right Alignment','prime-seo-agency'),
            'center-align' => __('Center Alignment','prime-seo-agency'),
            'left-align' => __('Left Alignment','prime-seo-agency'),
        ),
    ) );

    /** Scroll to top button shape */
    $wp_customize->add_setting('prime_seo_agency_scroll_to_top_radius', array(
        'default'           => 'curved-box',
        'sanitize_callback' => 'prime_seo_agency_sanitize_choices',
    ));

    $wp_customize->add_control('prime_seo_agency_scroll_to_top_radius', array(
        'label'    => __('Scroll Top Button Shape', 'prime-seo-agency'),
        'section'  => 'prime_seo_agency_footer_section',
        'settings' => 'prime_seo_agency_scroll_to_top_radius',
        'type'     => 'select',
        'choices'  => array(
            'box'        => __( 'Box', 'prime-seo-agency' ),
            'curved-box' => __( 'Curved Box', 'prime-seo-agency' ),
            'circle'     => __( 'Circle', 'prime-seo-agency' ),
        ),
    ));

    // 404 PAGE SETTINGS
    $wp_customize->add_section(
        'prime_seo_agency_404_section',
        array(
            'title' => __( '404 Page Settings', 'prime-seo-agency' ),
            'priority' => 70,
            'panel' => 'prime_seo_agency_general_settings',
        )
    );
   
    $wp_customize->add_setting('404_page_image', array(
        'default' => '',
        'transport' => 'refresh',
        'sanitize_callback' => 'esc_url_raw', // Sanitize as URL
    ));

    $wp_customize->add_control(new WP_Customize_Image_Control($wp_customize, '404_page_image', array(
        'label' => __('404 Page Image', 'prime-seo-agency'),
        'section' => 'prime_seo_agency_404_section',
        'settings' => '404_page_image',
    )));

    $wp_customize->add_setting('404_pagefirst_header', array(
        'default' => __('404', 'prime-seo-agency'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_pagefirst_header', array(
        'type' => 'text',
        'label' => __('Heading', 'prime-seo-agency'),
        'section' => 'prime_seo_agency_404_section',
    ));

    // Setting for 404 page header
    $wp_customize->add_setting('404_page_header', array(
        'default' => __('Sorry, that page can\'t be found!', 'prime-seo-agency'),
        'transport' => 'refresh',
        'sanitize_callback' => 'sanitize_text_field', // Sanitize as text field
    ));

    $wp_customize->add_control('404_page_header', array(
        'type' => 'text',
        'label' => __('Heading', 'prime-seo-agency'),
        'section' => 'prime_seo_agency_404_section',
    ));

}
add_action( 'customize_register', 'prime_seo_agency_customize_register' );
endif;

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function prime_seo_agency_customize_preview_js() {
    // Use minified libraries if SCRIPT_DEBUG is false
    $prime_seo_agency_build  = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '/build' : '';
    $prime_seo_agency_suffix = ( defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ) ? '' : '.min';
	wp_enqueue_script( 'prime_seo_agency_customizer', get_template_directory_uri() . '/js' . $prime_seo_agency_build . '/customizer' . $prime_seo_agency_suffix . '.js', array( 'customize-preview' ), '20130508', true );
}
add_action( 'customize_preview_init', 'prime_seo_agency_customize_preview_js' );